//###########################################################################

//
// Included Files
//
#include <motor-controller.h>
#include <motor-controller.h>
#include "driverlib.h"
#include "board.h"

//
// Defines
//
#define WAITSTEP     asm(" RPT #255 || NOP")

//
// Globals
//

//
//Task 1 (C) Variables
// NOTE: Do not initialize the Message RAM variables globally, they will be
// reset during the message ram initialization phase in the CLA memory
// configuration routine
//
#ifdef __cplusplus
#pragma DATA_SECTION("CpuToCla1MsgRAM");
float fVal;
#pragma DATA_SECTION("Cla1ToCpuMsgRAM");
float fResult;
#else
#pragma DATA_SECTION(fVal,"CpuToCla1MsgRAM");
float fVal;
#pragma DATA_SECTION(ADCA0_Result,"Cla1ToCpuMsgRAM");
float ADCA0_Result;
#pragma DATA_SECTION(ADCA1_Result,"Cla1ToCpuMsgRAM");
float ADCA1_Result;
#pragma DATA_SECTION(ADCA2_Result,"Cla1ToCpuMsgRAM");
float ADCA2_Result;
#pragma DATA_SECTION(ADCA3_Result,"Cla1ToCpuMsgRAM");
float ADCA3_Result;
#pragma DATA_SECTION(ADCA4_Result,"Cla1ToCpuMsgRAM");
float ADCA4_Result;
#pragma DATA_SECTION(ADCA5_Result,"Cla1ToCpuMsgRAM");
float ADCA5_Result;
#pragma DATA_SECTION(ADCB14_Result,"Cla1ToCpuMsgRAM");
float ADCB14_Result;
#pragma DATA_SECTION(ADCB15_Result,"Cla1ToCpuMsgRAM");
float ADCB15_Result;
#endif //__cplusplus
float y[BUFFER_SIZE];

//
//Task 2 (C) Variables
//

//
//Task 3 (C) Variables
//

//
//Task 4 (C) Variables
//

//
//Task 5 (C) Variables
//

//
//Task 6 (C) Variables
//

//
//Task 7 (C) Variables
//

//
//Task 8 (C) Variables
//

//
//Common (C) Variables
//The Exponential table
//
enum {
    ADCA_IN0=0,
    ADCA_IN1,
    ADCA_IN2,
    ADCA_IN3,
    ADCA_IN4,
    ADCA_IN5,
    ADCA_max
};
uint16_t pDataADC_A[ADCA_max];
enum {
    ADCB_IN0=0,
    ADCB_IN1,
    ADCB_IN2,
    ADCB_IN3,
    ADCB_IN4,
    ADCB_IN5,
    ADCB_IN14,
    ADCB_IN15,
    ADCB_max
};
uint16_t pDataADC_B[ADCB_max];

float adc0;
//
// Function Prototypes
//
__interrupt void cla1Isr1();
__interrupt void cla1Isr2();
__interrupt void cla1Isr3();
__interrupt void cla1Isr4();
__interrupt void cla1Isr5();
__interrupt void cla1Isr6();
__interrupt void cla1Isr7();
__interrupt void cla1Isr8();

//
// Main
//
void main(void)
{

    //
    // Intialize device clock and peripherals
    //
    Device_init();

    //
    // Disable pin locks and enable internal pullups.
    //
    //Device_initGPIO(); //skipped for this example

    //
    // Initialize PIE and clear PIE registers. Disables CPU interrupts
    //
    Interrupt_initModule();

    //
    // Initialize the PIE vector table with pointers to the shell Interrupt
    // Service Routines (ISR).
    //
    Interrupt_initVectorTable();

    //
    // Initialize resources
    //
    Board_init();

    //
    // Enable Global Interrupt (INTM) and realtime interrupt (DBGM)
    //
    EINT;
    ERTM;

    for(;;)
    {
        CLA_forceTasks(CLA1_BASE,CLA_TASKFLAG_1);
//        ADC_forceSOC(myADC0_BASE, ADC_SOC_NUMBER0);
//        ADC_forceSOC(myADC0_BASE, ADC_SOC_NUMBER1);
//        ADC_forceSOC(myADC0_BASE, ADC_SOC_NUMBER2);
//        ADC_forceSOC(myADC0_BASE, ADC_SOC_NUMBER3);
//        ADC_forceSOC(myADC0_BASE, ADC_SOC_NUMBER4);
        ADC_forceSOC(myADC0_BASE, ADC_SOC_NUMBER5);
//        ADC_forceSOC(myADC1_BASE, ADC_SOC_NUMBER6);
//        ADC_forceSOC(myADC1_BASE, ADC_SOC_NUMBER7);
//        EPWM_setCounterCompareValue(myEPWM1_BASE, EPWM_COUNTER_COMPARE_A, 2500);
//        GPIO_togglePin(myGPIO4);
        DEVICE_DELAY_US(2500);
//        EPWM_setCounterCompareValue(myEPWM1_BASE, EPWM_COUNTER_COMPARE_A, 0);
////        GPIO_togglePin(myGPIO6);
//        DEVICE_DELAY_US(250000);
    }
}


//
// cla1Isr1 - CLA1 ISR 1
//

__interrupt void cla1Isr1 ()
{
    //
    // Acknowledge the end-of-task interrupt for task 1
    //
    ADC_clearInterruptStatus(myADC0_BASE, ADC_INT_NUMBER1);
    Interrupt_clearACKGroup(INTERRUPT_ACK_GROUP11);

//    pDataADC_A[ADCA_IN0] = ADCA0_Result;
//    pDataADC_A[ADCA_IN1] = ADCA1_Result;
//    pDataADC_A[ADCA_IN2] = ADCA2_Result;
//    pDataADC_A[ADCA_IN3] = ADCA3_Result;
//    pDataADC_A[ADCA_IN4] = ADCA4_Result;
    pDataADC_A[ADCA_IN5] = ADCA5_Result;
//    GPIO_togglePin(myGPIO4);
    //
    // Uncomment to halt debugger and stop here
    //
    // asm(" ESTOP0");
}

//
// cla1Isr2 - CLA1 ISR 2
//
__interrupt void cla1Isr2 ()
{
    //
    // Acknowledge the end-of-task interrupt for task 8
    //
//    ADC_clearInterruptStatus(myADC0_BASE, ADC_INT_NUMBER1);
    Interrupt_clearACKGroup(INTERRUPT_ACK_GROUP11);

//    pDataADC_A[ADCA_INA1] = ADCA1_Result;
    //
    // Uncomment to halt debugger and stop here
    //
//    asm(" ESTOP0");
}

//
// cla1Isr3 - CLA1 ISR 3
//
__interrupt void cla1Isr3 ()
{
    //
    // Acknowledge the end-of-task interrupt for task 8
    //
//    ADC_clearInterruptStatus(myADC0_BASE, ADC_INT_NUMBER1);
    Interrupt_clearACKGroup(INTERRUPT_ACK_GROUP11);

//    pDataADC_A[ADCA_INA2] = ADCA2_Result;
    //
    // Uncomment to halt debugger and stop here
    //
//    asm(" ESTOP0");
}

//
// cla1Isr4 - CLA1 ISR 4
//
__interrupt void cla1Isr4 ()
{
    //
    // Acknowledge the end-of-task interrupt for task 8
    //
//    ADC_clearInterruptStatus(myADC0_BASE, ADC_INT_NUMBER1);
    Interrupt_clearACKGroup(INTERRUPT_ACK_GROUP11);

//    pDataADC_A[ADCA_INA3] = ADCA3_Result;
    //
    // Uncomment to halt debugger and stop here
    //
//    asm(" ESTOP0");
}

//
// cla1Isr5 - CLA1 ISR 5
//
__interrupt void cla1Isr5 ()
{
    //
    // Acknowledge the end-of-task interrupt for task 8
    //
//    ADC_clearInterruptStatus(myADC0_BASE, ADC_INT_NUMBER1);
    Interrupt_clearACKGroup(INTERRUPT_ACK_GROUP11);

//    pDataADC_A[ADCA_INA4] = ADCA4_Result;
    //
    // Uncomment to halt debugger and stop here
    //
//    asm(" ESTOP0");
}

//
// cla1Isr6 - CLA1 ISR 6
//
__interrupt void cla1Isr6 ()
{
    //
    // Acknowledge the end-of-task interrupt for task 8
    //
//    ADC_clearInterruptStatus(myADC0_BASE, ADC_INT_NUMBER1);
    Interrupt_clearACKGroup(INTERRUPT_ACK_GROUP11);

//    pDataADC_A[ADCA_INA5] = ADCA5_Result;
    //
    // Uncomment to halt debugger and stop here
    //
//    asm(" ESTOP0");
}

//
// cla1Isr7 - CLA1 ISR 7
//
__interrupt void cla1Isr7 ()
{
    //
    // Acknowledge the end-of-task interrupt for task 8
    //
//    ADC_clearInterruptStatus(myADC0_BASE, ADC_INT_NUMBER1);
    Interrupt_clearACKGroup(INTERRUPT_ACK_GROUP11);

//    pDataADC_B[ADCB_IN14] = ADCB14_Result;
    //
    // Uncomment to halt debugger and stop here
    //
//    asm(" ESTOP0");
}

//
// cla1Isr8 - CLA1 ISR 8
//
__interrupt void cla1Isr8 ()
{
    //
    // Acknowledge the end-of-task interrupt for task 8
    //
//    ADC_clearInterruptStatus(myADC0_BASE, ADC_INT_NUMBER1);
    Interrupt_clearACKGroup(INTERRUPT_ACK_GROUP11);

//    pDataADC_B[ADCB_IN15] = ADCB15_Result;
    //
    // Uncomment to halt debugger and stop here
    //
//    asm(" ESTOP0");
}

//
// End of file
//
